
; PICBASIC PRO(TM) Compiler 3.0.7.4, (c) 1998, 2013 microEngineering Labs, Inc. All Rights Reserved. 
MPASMWIN_USED			EQU	1

#define	PBP_PATH	C:\TOOLS\MELABS\V3.0.7\




        NOLIST
    ifdef PM_USED
        LIST
        "Error: PM does not support this device.  Use MPASM."
        NOLIST
    else
        LIST
        LIST p = 18F26J50, r = dec, w = -311, f = inhx32
        INCLUDE PBP_PATH\DEVICES\PIC18F26J50.MPASMINC	; MPASM  Header
        NOLIST
    endif
        LIST
BLOCK_SIZE	EQU	64


PBP_HARDWAREDEF  macro
  endm


    CONFIG  WDTEN = ON            ; Enabled
    CONFIG  PLLDIV = 5            ; Divide by 5 (20 MHz oscillator input)
    CONFIG  STVREN = ON           ; Enabled
    CONFIG  XINST = OFF           ; Disabled
    CONFIG  DEBUG = OFF           ; Disabled
    CONFIG  CPUDIV = OSC1         ; No CPU system clock divide
    CONFIG  CP0 = OFF             ; Program memory is not code-protected
    CONFIG  OSC = HSPLL           ; HS+PLL, USB-HS+PLL
    CONFIG  T1DIG = ON            ; Secondary Oscillator clock source may be selected
    CONFIG  LPT1OSC = OFF         ; High-power operation
    CONFIG  FCMEN = OFF           ; Disabled
    CONFIG  IESO = OFF            ; Disabled
    CONFIG  WDTPS = 512           ; 1:512
    CONFIG  DSWDTOSC = INTOSCREF  ; DSWDT uses INTRC
    CONFIG  RTCOSC = T1OSCREF     ; RTCC uses T1OSC/T1CKI
    CONFIG  DSBOREN = ON          ; Enabled
    CONFIG  DSWDTEN = ON          ; Enabled
    CONFIG  DSWDTPS = G2          ; 1:2,147,483,648 (25.7 days)
    CONFIG  IOL1WAY = ON          ; The IOLOCK bit (PPSCON<0>) can be set once
    CONFIG  MSSP7B_EN = MSK7      ; 7 Bit address masking mode
    CONFIG  WPFP = PAGE_0         ; Write Protect Program Flash Page 0
    CONFIG  WPEND = PAGE_WPFP     ; Page WPFP<5:0> through Configuration Words erase/write protected
    CONFIG  WPCFG = OFF           ; Configuration Words page not erase/write-protected
    CONFIG  WPDIS = OFF           ; WPFP<5:0>/WPEND region ignored


RAM_START       		EQU	00000h
RAM_END         		EQU	00EBFh
RAM_BANKS       		EQU	0000Fh
BANK0_START     		EQU	00060h
BANK0_END       		EQU	000FFh
BANK1_START     		EQU	00100h
BANK1_END       		EQU	001FFh
BANK2_START     		EQU	00200h
BANK2_END       		EQU	002FFh
BANK3_START     		EQU	00300h
BANK3_END       		EQU	003FFh
BANK4_START     		EQU	00400h
BANK4_END       		EQU	004FFh
BANK5_START     		EQU	00500h
BANK5_END       		EQU	005FFh
BANK6_START     		EQU	00600h
BANK6_END       		EQU	006FFh
BANK7_START     		EQU	00700h
BANK7_END       		EQU	007FFh
BANK8_START     		EQU	00800h
BANK8_END       		EQU	008FFh
BANK9_START     		EQU	00900h
BANK9_END       		EQU	009FFh
BANK10_START    		EQU	00A00h
BANK10_END      		EQU	00AFFh
BANK11_START    		EQU	00B00h
BANK11_END      		EQU	00BFFh
BANK12_START    		EQU	00C00h
BANK12_END      		EQU	00CFFh
BANK13_START    		EQU	00D00h
BANK13_END      		EQU	00DFFh
BANK14_START    		EQU	00E00h
BANK14_END      		EQU	00EBFh
BANKA_START     		EQU	00000h
BANKA_END       		EQU	0005Fh

; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00028	A00000	FLAGS   VAR     BYTE BANKA SYSTEM       ' Static flags
FLAGS           		EQU	RAM_START + 000h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00027	A00001	GOP     VAR     BYTE BANKA SYSTEM       ' Gen Op Parameter
GOP             		EQU	RAM_START + 001h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00016	A00002	R4      VAR     WORD BANKA SYSTEM       ' System Register
R4              		EQU	RAM_START + 002h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00017	A00004	R5      VAR     WORD BANKA SYSTEM       ' System Register
R5              		EQU	RAM_START + 004h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00018	A00006	R6      VAR     WORD BANKA SYSTEM       ' System Register
R6              		EQU	RAM_START + 006h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00019	A00008	R7      VAR     WORD BANKA SYSTEM       ' System Register
R7              		EQU	RAM_START + 008h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00020	A0000A	R8      VAR     WORD BANKA SYSTEM       ' System Register
R8              		EQU	RAM_START + 00Ah
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00023	A0000C	RM1     VAR     BYTE BANKA SYSTEM       ' Pin 1 Mask
RM1             		EQU	RAM_START + 00Ch
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00026	A0000D	RM2     VAR     BYTE BANKA SYSTEM       ' Pin 2 Mask
RM2             		EQU	RAM_START + 00Dh
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00021	A0000E	RR1     VAR     BYTE BANKA SYSTEM       ' Pin 1 Register
RR1             		EQU	RAM_START + 00Eh
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00024	A0000F	RR2     VAR     BYTE BANKA SYSTEM       ' Pin 2 Register
RR2             		EQU	RAM_START + 00Fh
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00022	A00010	RS1     VAR     BYTE BANKA SYSTEM       ' Pin 1 Bank
RS1             		EQU	RAM_START + 010h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00025	A00011	RS2     VAR     BYTE BANKA SYSTEM       ' Pin 2 Bank
RS2             		EQU	RAM_START + 011h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00012	A00012	R0      VAR     LONG BANKA SYSTEM       ' System Register
R0              		EQU	RAM_START + 012h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00013	A00016	R1      VAR     LONG BANKA SYSTEM       ' System Register
R1              		EQU	RAM_START + 016h
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00014	A0001A	R2      VAR     LONG BANKA SYSTEM       ' System Register
R2              		EQU	RAM_START + 01Ah
; C:\TOOLS\MELABS\V3.0.7\PBPPI18L.RAM	00015	A0001E	R3      VAR     LONG BANKA SYSTEM       ' System Register
R3              		EQU	RAM_START + 01Eh
; C:\TOOLS\MICROCHIP\PROJECTS\ROBOTBASIC COMMANDER\CDC_DESC.BAS	00007	A00400	USBReservedMemory Var Byte[USBMEMORYSIZE] USBMEMORYADDRESS	' Reserve memory used by USB assembler code
_USBReservedMemory		EQU	RAM_START + 000000400h
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00383	PORTL   VAR     PORTB
_PORTL           		EQU	 PORTB
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00384	PORTH   VAR     PORTC
_PORTH           		EQU	 PORTC
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00385	TRISL   VAR     TRISB
_TRISL           		EQU	 TRISB
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00386	TRISH   VAR     TRISC
_TRISH           		EQU	 TRISC

; Constants.
_USBMEMORYADDRESS		EQU	00400h
_USBMEMORYSIZE   		EQU	00100h

; EEPROM data.


	INCLUDE	"CDC_DESC.MAC"
	INCLUDE	"C:\TOOLS\MELABS\V3.0.7\PBPPI18L.LIB"


; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00036	Z00002	#HEADER
Z00002
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00051	Z00003	#MSG "Using assembly header DEVICES\PIC18F26J50.MPASMINC"
Z00003
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00061	Z00004	#CONFIG
Z00004
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00358	Z00005	BANKA   $0000, $005F
Z00005
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00359	Z00006	BANK0   $0060, $00FF
Z00006
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00360	Z00007	BANK1   $0100, $01FF
Z00007
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00361	Z00008	BANK2   $0200, $02FF
Z00008
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00362	Z00009	BANK3   $0300, $03FF
Z00009
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00363	Z0000A	BANK4   $0400, $04FF
Z0000A
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00364	Z0000B	BANK5   $0500, $05FF
Z0000B
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00365	Z0000C	BANK6   $0600, $06FF
Z0000C
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00366	Z0000D	BANK7   $0700, $07FF
Z0000D
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00367	Z0000E	BANK8   $0800, $08FF
Z0000E
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00368	Z0000F	BANK9   $0900, $09FF
Z0000F
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00369	Z00010	BANK10  $0A00, $0AFF
Z00010
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00370	Z00011	BANK11  $0B00, $0BFF
Z00011
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00371	Z00012	BANK12  $0C00, $0CFF
Z00012
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00372	Z00013	BANK13  $0D00, $0DFF
Z00013
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00373	Z00014	BANK14  $0E00, $0EBF
Z00014
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00374	Z00015	
Z00015
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00376	Z00016	    #MSG "LONG Variables enabled (PBPL used)"
Z00016
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00377	Z00017	    LIBRARY  "PBPPI18L"
Z00017

; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00378	Z00018	    INCLUDE "PBPPI18L.RAM"
Z00018
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00381	Z00019	    INCLUDE "PBPPIC18.RAM"
Z00019
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00382	Z0001A	#ENDIF
Z0001A
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00387	Z0001B	USBMEMORYADDRESS Con	$400	' USB RAM starts here
Z0001B
; C:\TOOLS\MELABS\V3.0.7\DEVICES\PIC18F26J50.PBPINC	00391	Z0001C	#HEADER
Z0001C
; C:\TOOLS\MICROCHIP\PROJECTS\ROBOTBASIC COMMANDER\CDC_DESC.BAS	00006	Z0001D	USBMEMORYSIZE	Con	256	' USB RAM size in bytes
Z0001D

; C:\TOOLS\MICROCHIP\PROJECTS\ROBOTBASIC COMMANDER\CDC_DESC.BAS	00009	Z0001E		Goto	cdc_desc_end	' Skip over all of the USB assembler code
Z0001E
	GOTO?L	_cdc_desc_end

; C:\TOOLS\MICROCHIP\PROJECTS\ROBOTBASIC COMMANDER\CDC_DESC.BAS	00011	Z0001F		Asm
Z0001F

	ASM?


#define USB_EP0_BUFF_SIZE	8	; 8, 16, 32, or 64
#define USB_MAX_NUM_INT		2
#define USB_MAX_EP_NUMBER	3
#define NUM_CONFIGURATIONS	1
#define NUM_INTERFACES		2

#define UCFG_VAL	USB_PULLUP_ENABLE|USB_INTERNAL_TRANSCEIVER|USB_FULL_SPEED|USB_PING_PONG__NO_PING_PONG
;#define UCFG_VAL	USB_PULLUP_ENABLE|USB_INTERNAL_TRANSCEIVER|USB_LOW_SPEED|USB_PING_PONG__NO_PING_PONG

;#define USE_SELF_POWER_SENSE_IO
;#define USE_USB_BUS_SENSE_IO

#define USB_POLLING

; CDC
; Endpoints Allocation
#define CDC_COMM_INTF_ID	0x00
#define CDC_COMM_EP		2
#define CDC_COMM_IN_EP_SIZE	8

#define CDC_DATA_INTF_ID	0x01
#define CDC_DATA_EP		3
#define CDC_DATA_OUT_EP_SIZE	64
#define CDC_DATA_IN_EP_SIZE	64

	include	"usb_cdc.asm"	; Include rest of USB files, starting with CDC class code

; ******************************************************************
; This table is polled by the host immediately after USB Reset has been released.
; This table defines the maximum packet size EP0 can take.
; See section 9.6.1 of the Rev 1.0 USB specification.
; These fields are application DEPENDENT. Modify these to meet
; your specifications.
; ******************************************************************
DeviceDescriptor
	retlw	(EndDeviceDescriptor-DeviceDescriptor)/2	; Size of this descriptor in bytes
	retlw	USB_DESCRIPTOR_DEVICE	; DEVICE descriptor type
	retlw	0x10		; USB Spec Release Number in BCD format - 1.10 (low byte)
	retlw	0x01		; (high byte)
	retlw	CDC_DEVICE	; Class Code
	retlw	0x00		; Subclass code
	retlw	0x00		; Protocol code
	retlw	USB_EP0_BUFF_SIZE	; Max packet size for EP0
	retlw	0xD8		; Vendor ID - 0x04D8 is Microchip Vendor ID (low byte)
	retlw	0x04		; (high byte)
	retlw	0x0A		; Product ID: CDC RS-232 Emulation Demo (low byte)
	retlw	0x00		; (high byte)
	retlw	0x01		; Device release number in BCD format (low byte)
	retlw	0x00		; (high byte)
	retlw	0x01		; Manufacturer string index
	retlw	0x02		; Product string index
	retlw	0x00		; Device serial number string index
	retlw	NUM_CONFIGURATIONS	; Number of possible configurations
EndDeviceDescriptor

; ******************************************************************
; This table is retrieved by the host after the address has been set.
; This table defines the configurations available for the device.
; See section 9.6.2 of the Rev 1.0 USB specification (page 184).
; These fields are application DEPENDENT. 
; Modify these to meet your specifications.
; ******************************************************************
; Configuration pointer table
USB_CD_Ptr
Configs
	db	low Config1, high Config1
	db	upper Config1, 0

; Configuration Descriptor
Config1
	retlw	(Interface1-Config1)/2	; Size of this descriptor in bytes
	retlw	USB_DESCRIPTOR_CONFIGURATION	; CONFIGURATION descriptor type
Config1Len
	retlw	low ((EndConfig1-Config1)/2)	; Total length of data for this cfg
	retlw	high ((EndConfig1-Config1)/2)
	retlw	NUM_INTERFACES	; Number of interfaces in this cfg
	retlw	0x01		; Index value of this configuration
	retlw	0x00		; Configuration string index
	retlw	_DEFAULT|_SELF	; Attributes
	retlw	50		; Max power consumption (2X mA)
Interface1
	retlw	(CDCDescriptor1-Interface1)/2	; Size of this descriptor in bytes
	retlw	USB_DESCRIPTOR_INTERFACE	; INTERFACE descriptor type
	retlw	0x00		; Interface Number
	retlw	0x00		; Alternate Setting Number
	retlw	0x01		; Number of endpoints in this intf
	retlw	COMM_INTF	; Class code
	retlw	ABSTRACT_CONTROL_MODEL	; Subclass code
	retlw	V25TER		; Protocol code
	retlw	0x00		; Interface string index
CDCDescriptor1
	retlw	(CDCDescriptor2-CDCDescriptor1)/2	; Size of this descriptor in bytes
	retlw	CS_INTERFACE	; Descriptor type
	retlw	DSC_FN_HEADER	; Descriptor sub type
	retlw	0x10		; (low byte)
	retlw	0x01		; (high byte)
CDCDescriptor2
	retlw	(CDCDescriptor3-CDCDescriptor2)/2	; Size of this descriptor in bytes
	retlw	CS_INTERFACE	; Descriptor type
	retlw	DSC_FN_ACM	; Descriptor sub type
	retlw	0x02		;USB_CDC_ACM_FN_DSC_VAL	; Capabilities
CDCDescriptor3
	retlw	(CDCDescriptor4-CDCDescriptor3)/2	; Size of this descriptor in bytes
	retlw	CS_INTERFACE	; Descriptor type
	retlw	DSC_FN_UNION	; Descriptor sub type
	retlw	CDC_COMM_INTF_ID	; Master interface
	retlw	CDC_DATA_INTF_ID	; Slave interface
CDCDescriptor4
	retlw	(Endpoint2-CDCDescriptor4)/2	; Size of this descriptor in bytes
	retlw	CS_INTERFACE	; Descriptor type
	retlw	DSC_FN_CALL_MGT	; Descriptor sub type
	retlw	0x00		; Capabilities
	retlw	CDC_DATA_INTF_ID	; Data interface
Endpoint2
	retlw	(Interface2-Endpoint2)/2	; Size of this descriptor in bytes
	retlw	USB_DESCRIPTOR_ENDPOINT	; ENDPOINT descriptor type
	retlw	CDC_COMM_EP|_EP_IN	;_EP02_IN	; Endpoint Address
	retlw	_INT		; Attributes
	retlw	low (CDC_COMM_IN_EP_SIZE)	; Size of the endpoint buffer in bytes (low byte)
	retlw	high (CDC_COMM_IN_EP_SIZE)	; (high byte)
	retlw	0x02		; Polling interval (2ms)
Interface2
	retlw	(Endpoint3Out-Interface2)/2	; Size of this descriptor in bytes
	retlw	USB_DESCRIPTOR_INTERFACE	; INTERFACE descriptor type
	retlw	0x01		; Interface Number
	retlw	0x00		; Alternate Setting Number
	retlw	0x02		; Number of endpoints in this intf
	retlw	DATA_INTF	; Class code
	retlw	0x00		; Subclass code
	retlw	NO_PROTOCOL		; Protocol code
	retlw	0x00		; Interface string index
Endpoint3Out
	retlw	(Endpoint3In-Endpoint3Out)/2	; Size of this descriptor in bytes
	retlw	USB_DESCRIPTOR_ENDPOINT	; ENDPOINT descriptor type
	retlw	CDC_DATA_EP|_EP_OUT	;_EP03_OUT	; Endpoint Address
	retlw	_BULK		; Attributes
	retlw	low (CDC_DATA_OUT_EP_SIZE)	; Size of the endpoint buffer in bytes (low byte)
	retlw	high (CDC_DATA_OUT_EP_SIZE)	; (high byte)
	retlw	0x00		; Polling interval
Endpoint3In
	retlw	(EndConfig1-Endpoint3In)/2	; Size of this descriptor in bytes
	retlw	USB_DESCRIPTOR_ENDPOINT	; ENDPOINT descriptor type
	retlw	CDC_DATA_EP|_EP_IN	;_EP03_IN	; Endpoint Address
	retlw	_BULK		; Attributes
	retlw	low (CDC_DATA_IN_EP_SIZE)	; Size of the endpoint buffer in bytes (low byte)
	retlw	high (CDC_DATA_IN_EP_SIZE)	; (high byte)
	retlw	0x00		; Polling interval
EndConfig1


; String pointer table
USB_SD_Ptr
Strings
	db	low String0, high String0
	db	upper String0, 0
	db	low String1, high String1
	db	upper String1, 0
	db	low String2, high String2
	db	upper String2, 0

; Language code string descriptor
String0
	retlw   (String1-String0)/2	; Size of this descriptor in bytes
	retlw   USB_DESCRIPTOR_STRING	; STRING descriptor type
	retlw   0x09		; Language ID as defined by MS - 0x0409 (low byte)
	retlw   0x04		; (high byte)

; Manufacturer string descriptor
String1
	retlw   (String2-String1)/2	; Size of this descriptor in bytes
	retlw   USB_DESCRIPTOR_STRING	; STRING descriptor type
	retlw   'M'
	retlw   0x00
	retlw   'i'
	retlw   0x00
	retlw   'c'
	retlw   0x00
	retlw   'r'
	retlw   0x00
	retlw   'o'
	retlw   0x00
	retlw   'c'
	retlw   0x00
	retlw   'h'
	retlw   0x00
	retlw   'i'
	retlw   0x00
	retlw   'p'
	retlw   0x00
	retlw   ' '
	retlw   0x00
	retlw   'T'
	retlw   0x00
	retlw   'e'
	retlw   0x00
	retlw   'c'
	retlw   0x00
	retlw   'h'
	retlw   0x00
	retlw   'n'
	retlw   0x00
	retlw   'o'
	retlw   0x00
	retlw   'l'
	retlw   0x00
	retlw   'o'
	retlw   0x00
	retlw   'g'
	retlw   0x00
	retlw   'y'
	retlw   0x00
	retlw   ' '
	retlw   0x00
	retlw   'I'
	retlw   0x00
	retlw   'n'
	retlw   0x00
	retlw   'c'
	retlw   0x00
	retlw   '.'
	retlw   0x00

; Product string descriptor
String2
	retlw   (EndStringDescriptors-String2)/2	; Size of this descriptor in bytes
	retlw   USB_DESCRIPTOR_STRING	; STRING descriptor type
	retlw   'C'
	retlw   0x00
	retlw   'D'
	retlw   0x00
	retlw   'C'
	retlw   0x00
	retlw   ' '
	retlw   0x00
	retlw   'R'
	retlw   0x00
	retlw   'S'
	retlw   0x00
	retlw   '-'
	retlw   0x00
	retlw   '2'
	retlw   0x00
	retlw   '3'
	retlw   0x00
	retlw   '2'
	retlw   0x00
	retlw   ' '
	retlw   0x00
	retlw   'E'
	retlw   0x00
	retlw   'm'
	retlw   0x00
	retlw   'u'
	retlw   0x00
	retlw   'l'
	retlw   0x00
	retlw   'a'
	retlw   0x00
	retlw   't'
	retlw   0x00
	retlw   'i'
	retlw   0x00
	retlw   'o'
	retlw   0x00
	retlw   'n'
	retlw   0x00
	retlw   ' '
	retlw   0x00
	retlw   'D'
	retlw   0x00
	retlw   'e'
	retlw   0x00
	retlw   'm'
	retlw   0x00
	retlw   'o'
	retlw   0x00
EndStringDescriptors

	

	ENDASM?


; C:\TOOLS\MICROCHIP\PROJECTS\ROBOTBASIC COMMANDER\CDC_DESC.BAS	00293	Z00020	cdc_desc_end			' End of skipped over USB assembler code
Z00020

	LABEL?L	_cdc_desc_end	

	END
